Package org.apache.commons.jxpath.ri.model.jdom

# Class JDOMAttributePointer

java.lang.Object
org.apache.commons.jxpath.ri.model.NodePointer
org.apache.commons.jxpath.ri.model.jdom.JDOMAttributePointer

All Implemented Interfaces:
  `Serializable`, `Cloneable`, `Comparable`, `Pointer`

public class JDOMAttributePointer extends NodePointer
A Pointer that points to a DOM node.

See Also:
  - Serialized Form

- ## Field Summary

  ### Fields inherited from class org.apache.commons.jxpath.ri.model.NodePointer

  `index, locale, parent, UNKNOWN_NAMESPACE, WHOLE_COLLECTION`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `JDOMAttributePointer(NodePointer parent, Attribute attribute)`
  Create a JDOMAttributePointer.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `String`
  `asPath()`
  Returns an XPath that maps to this Pointer.
  `int`
  `compareChildNodePointers(NodePointer pointer1, NodePointer pointer2)`
  Compares two child NodePointers and returns a positive number, zero or a positive number according to the order of the pointers.
  `boolean`
  `equals(Object object)`
  `Object`
  `getBaseValue()`
  Gets the value represented by the pointer before indexing.
  `Object`
  `getImmediateNode()`
  Returns the object the pointer points to; does not convert it to a "canonical" type.
  `int`
  `getLength()`
  If the pointer represents a collection (or collection element), returns the length of the collection.
  `QName`
  `getName()`
  Gets the name of this node.
  `String`
  `getNamespaceURI()`
  Returns the namespace URI associated with this Pointer.
  `Object`
  `getValue()`
  By default, returns `getNode()`, can be overridden to return a "canonical" value, like for instance a DOM element should return its string value.
  `int`
  `hashCode()`
  `boolean`
  `isActual()`
  An actual pointer points to an existing part of an object graph, even if it is null.
  `boolean`
  `isCollection()`
  Returns `true` if the value of the pointer is an array or a Collection.
  `boolean`
  `isLeaf()`
  If true, this node does not have children
  `void`
  `remove()`
  Remove the node of the object graph this pointer points to.
  `void`
  `setValue(Object value)`
  Converts the value to the required type and changes the corresponding object to that value.

  ### Methods inherited from class org.apache.commons.jxpath.ri.model.NodePointer

  `attributeIterator, childIterator, clone, compareTo, createAttribute, createChild, createChild, createPath, createPath, escape, getAbstractFactory, getDefaultNamespaceURI, getImmediateParentPointer, getImmediateValuePointer, getIndex, getLocale, getNamespaceResolver, getNamespaceURI, getNode, getNodeSetByKey, getNodeValue, getParent, getPointerByID, getPointerByKey, getRootNode, getValuePointer, handle, handle, isAttribute, isContainer, isDefaultNamespace, isLanguage, isNode, isRoot, namespaceIterator, namespacePointer, newChildNodePointer, newNodePointer, printPointerChain, setAttribute, setExceptionHandler, setIndex, setNamespaceResolver, testNode, toString, verify`

  ### Methods inherited from class java.lang.Object

  `finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### JDOMAttributePointer

    public JDOMAttributePointer(NodePointer parent, Attribute attribute)
    Create a JDOMAttributePointer.
    Parameters:
      `parent` - NodePointer parent.
      `attribute` - JDOM Attribute.

- ## Method Details

  - ### asPath

    public String asPath()
    Description copied from class: `NodePointer`
    Returns an XPath that maps to this Pointer.
    Specified by:
      `asPath` in interface `Pointer`
    Overrides:
      `asPath` in class `NodePointer`
    Returns:
      String XPath expression

  - ### compareChildNodePointers

    public int compareChildNodePointers(NodePointer pointer1, NodePointer pointer2)
    Description copied from class: `NodePointer`
    Compares two child NodePointers and returns a positive number, zero or a positive number according to the order of the pointers.
    Specified by:
      `compareChildNodePointers` in class `NodePointer`
    Parameters:
      `pointer1` - first pointer to be compared
      `pointer2` - second pointer to be compared
    Returns:
      int per Java comparison conventions

  - ### equals

    public boolean equals(Object object)
    Overrides:
      `equals` in class `Object`

  - ### getBaseValue

    public Object getBaseValue()
    Description copied from class: `NodePointer`
    Gets the value represented by the pointer before indexing. So, if the node represents an element of a collection, this method returns the collection itself.
    Specified by:
      `getBaseValue` in class `NodePointer`
    Returns:
      Object value

  - ### getImmediateNode

    public Object getImmediateNode()
    Description copied from class: `NodePointer`
    Returns the object the pointer points to; does not convert it to a "canonical" type.
    Specified by:
      `getImmediateNode` in class `NodePointer`
    Returns:
      Object node

  - ### getLength

    public int getLength()
    Description copied from class: `NodePointer`
    If the pointer represents a collection (or collection element), returns the length of the collection. Otherwise returns 1 (even if the value is null).
    Specified by:
      `getLength` in class `NodePointer`
    Returns:
      the length.

  - ### getName

    public QName getName()
    Description copied from class: `NodePointer`
    Gets the name of this node. Can be null.
    Specified by:
      `getName` in class `NodePointer`
    Returns:
      QName The name of this node. Can be null.

  - ### getNamespaceURI

    public String getNamespaceURI()
    Description copied from class: `NodePointer`
    Returns the namespace URI associated with this Pointer.
    Overrides:
      `getNamespaceURI` in class `NodePointer`
    Returns:
      String uri

  - ### getValue

    public Object getValue()
    Description copied from class: `NodePointer`
    By default, returns `getNode()`, can be overridden to return a "canonical" value, like for instance a DOM element should return its string value.
    Specified by:
      `getValue` in interface `Pointer`
    Overrides:
      `getValue` in class `NodePointer`
    Returns:
      Object value

  - ### hashCode

    public int hashCode()
    Overrides:
      `hashCode` in class `Object`

  - ### isActual

    public boolean isActual()
    Description copied from class: `NodePointer`
    An actual pointer points to an existing part of an object graph, even if it is null. A non-actual pointer represents a part that does not exist at all. For instance consider the pointer "/address/street". If both address and street are not null, the pointer is actual. If address is not null, but street is null, the pointer is still actual. If address is null, the pointer is not actual. (In JavaBeans) if address is not a property of the root bean, a Pointer for this path cannot be obtained at all - actual or otherwise.
    Overrides:
      `isActual` in class `NodePointer`
    Returns:
      boolean

  - ### isCollection

    public boolean isCollection()
    Description copied from class: `NodePointer`
    Returns `true` if the value of the pointer is an array or a Collection.
    Specified by:
      `isCollection` in class `NodePointer`
    Returns:
      boolean

  - ### isLeaf

    public boolean isLeaf()
    Description copied from class: `NodePointer`
    If true, this node does not have children
    Specified by:
      `isLeaf` in class `NodePointer`
    Returns:
      boolean

  - ### remove

    public void remove()
    Description copied from class: `NodePointer`
    Remove the node of the object graph this pointer points to.
    Overrides:
      `remove` in class `NodePointer`

  - ### setValue

    public void setValue(Object value)
    Description copied from class: `NodePointer`
    Converts the value to the required type and changes the corresponding object to that value.
    Specified by:
      `setValue` in interface `Pointer`
    Specified by:
      `setValue` in class `NodePointer`
    Parameters:
      `value` - the value to set